#movement
scoreboard players add @e[type=slime,tag=ratKing,scores={waitT=..40}] waitT 1
execute if entity @e[tag=controller,type=armor_stand,scores={ratKingCount=1}] as @s[tag=!stuck,scores={waitT=40..}] at @s run tp @s ~ ~ ~-0.12 180 0
execute if entity @e[tag=controller,type=armor_stand,scores={ratKingCount=2..3}] as @s[tag=!stuck,scores={waitT=40..}] at @s run tp @s ~ ~ ~-0.125 180 0
execute if entity @e[tag=controller,type=armor_stand,scores={ratKingCount=4}] as @s[tag=!stuck,scores={waitT=40..}] at @s run tp @s ~ ~ ~-0.13 180 0

#push box
execute as @a[scores={sneakB=1..},y_rotation=50..130,nbt={OnGround:1b},limit=1] at @s unless block ~ ~-1 ~ air if block ~-0.5 ~ ~ coal_ore if block ~-2 ~ ~ air run function single:pushwest
execute as @a[scores={sneakB=1..},y_rotation=140..-140,nbt={OnGround:1b},limit=1] at @s unless block ~ ~-1 ~ air if block ~ ~ ~-0.5 coal_ore if block ~ ~ ~-2 air run function single:pushnorth
execute as @a[scores={sneakB=1..},y_rotation=-130..-50,nbt={OnGround:1b},limit=1] at @s unless block ~ ~-1 ~ air if block ~0.5 ~ ~ coal_ore if block ~2 ~ ~ air run function single:pusheast
execute as @a[scores={sneakB=1..},y_rotation=-40..40,nbt={OnGround:1b},limit=1] at @s unless block ~ ~-1 ~ air if block ~ ~ ~0.5 coal_ore if block ~ ~ ~2 air run function single:pushsouth
scoreboard players reset @a[scores={sneakB=1..}] sneakB

#kill/attack
execute at @s run kill @a[scores={player=1..,ratKing=1..},distance=..6]
execute at @s positioned ~ ~4 ~ run kill @a[scores={player=1..,ratKing=1..},distance=..6]

#silverfish
execute as @a[scores={player=1..,ratKing=1..}] at @s as @e[type=silverfish,tag=rat,distance=13..,tag=active,tag=!constant] run data merge entity @s {Attributes:[{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.followRange",Base:0.0}]}
execute as @a[scores={player=1..,ratKing=1..}] at @s as @e[type=silverfish,tag=rat,distance=13..,tag=active,tag=!constant] run tag @s remove active
execute as @a[scores={player=1..,ratKing=1..}] at @s as @e[type=silverfish,tag=rat,distance=..12,tag=!active,tag=!constant] run data merge entity @s {Attributes:[{Name:"generic.movementSpeed",Base:0.25},{Name:"generic.followRange",Base:40.0}]}
execute as @a[scores={player=1..,ratKing=1..}] at @s as @e[type=silverfish,tag=rat,distance=..12,tag=!active,tag=!constant] run tag @s add active

#spit
scoreboard players add @s ratKingT 1
execute as @s[scores={ratKingT=160}] at @s run summon silverfish ~ ~2 ~-6.5 {Motion:[0.0,0.2,-1.0],Tags:["ratKingM","rat","constant"],PersistenceRequired:1,Rotation:[180.0f,0.0f],Attributes:[{Name:"generic.maxHealth",Base:15.0},{Name:"generic.movementSpeed",Base:0.28},{Name:"generic.attackKnockback",Base:6.0},{Name:"generic.followRange",Base:40.0}],Health:15}
execute as @s[scores={ratKingT=160}] at @s run particle spit ~ ~2 ~-6.5 0.2 0.2 0.2 0 6 force @a
execute as @s[scores={ratKingT=160}] at @s positioned ~ ~2 ~-6.5 run playsound entity.llama.spit master @a ~ ~ ~ 4
execute as @s[scores={ratKingT=160}] run scoreboard players reset @s ratKingT

#set box in lava
execute as @e[type=falling_block] at @s if block ~ ~ ~ lava run playsound block.fire.extinguish master @a ~ ~ ~ 1
execute as @e[type=falling_block] at @s if block ~ ~ ~ lava if block ~1 ~ ~ lava run setblock ~1 ~ ~ cut_red_sandstone
execute as @e[type=falling_block] at @s if block ~ ~ ~ lava if block ~-1 ~ ~ lava run setblock ~-1 ~ ~ cut_red_sandstone
execute as @e[type=falling_block] at @s if block ~ ~ ~ lava if block ~ ~ ~1 lava run setblock ~ ~ ~1 cut_red_sandstone
execute as @e[type=falling_block] at @s if block ~ ~ ~ lava if block ~ ~ ~-1 lava run setblock ~ ~ ~-1 cut_red_sandstone
execute as @e[type=falling_block] at @s if block ~ ~ ~ lava run setblock ~ ~ ~ coal_ore
execute as @e[type=falling_block] at @s if block ~ ~ ~ lava run kill @s

#maze particles and effect
particle effect 747 8 -386 2 4 7 0 15 force @a
effect give @a[scores={player=1..,ratKing=1..},x=742,y=0,z=-405,dx=10,dy=20,dz=39] nausea 4 0 true

#kill in lava
execute as @a[scores={player=1..,ratKing=1..}] at @s if block ~ ~ ~ lava run kill @s

#kill rats
execute at @s run kill @e[type=silverfish,tag=rat,distance=..6]

#dispenser time
scoreboard players add @e[type=slime,tag=ratKing] dispenserT 1

#dispensers alternative ground
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1}] run playsound block.piston.contract master @a 747 6 -414 1
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1..40}] run particle flame 747 4 -414 2.6 0.8 0.3 0 15 force @a
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1..40}] run kill @a[scores={player=1..,ratKing=1..},x=742,y=4,z=-414,dx=10,dy=2,dz=0]

execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41}] run playsound block.piston.contract master @a 747 6 -418 1
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41..80}] run particle flame 747 4 -418 2.6 0.8 0.3 0 15 force @a
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41..80}] run kill @a[scores={player=1..,ratKing=1..},x=742,y=4,z=-418,dx=10,dy=2,dz=0]

execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1}] run playsound block.piston.contract master @a 747 6 -422 1
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1..40}] run particle flame 747 4 -422 2.6 0.8 0.3 0 15 force @a
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1..40}] run kill @a[scores={player=1..,ratKing=1..},x=742,y=4,z=-422,dx=10,dy=2,dz=0]

execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41}] run playsound block.piston.contract master @a 747 6 -432 1
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41..80}] run particle flame 747 4 -432 2.6 0.8 0.3 0 15 force @a
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41..80}] run kill @a[scores={player=1..,ratKing=1..},x=742,y=4,z=-432,dx=10,dy=2,dz=0]

execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1}] run playsound block.piston.contract master @a 747 6 -436 1
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1..40}] run particle flame 747 4 -436 2.6 0.8 0.3 0 15 force @a
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1..40}] run kill @a[scores={player=1..,ratKing=1..},x=742,y=4,z=-436,dx=10,dy=2,dz=0]

execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41}] run playsound block.piston.contract master @a 747 6 -440 1
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41..80}] run particle flame 747 4 -440 2.6 0.8 0.3 0 15 force @a
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41..80}] run kill @a[scores={player=1..,ratKing=1..},x=742,y=4,z=-440,dx=10,dy=2,dz=0]

#dispensers constant side
particle dust 1 0 0 1 747 4.4 -444 4 0.1 0.1 1 15 force @a
kill @a[scores={player=1..,ratKing=1..},x=742,y=3,z=-444,dx=10,dy=0.4,dz=0]
particle dust 1 0 0 1 747 4.4 -448 4 0.1 0.1 1 15 force @a
kill @a[scores={player=1..,ratKing=1..},x=742,y=3,z=-448,dx=10,dy=0.4,dz=0]
particle dust 1 0 0 1 747 4.4 -452 4 0.1 0.1 1 15 force @a
kill @a[scores={player=1..,ratKing=1..},x=742,y=3,z=-452,dx=10,dy=0.4,dz=0]

#dispensers constant ground
particle flame 750 4 -446 1.2 0.8 0.3 0 10 force @a
kill @a[scores={player=1..,ratKing=1..},x=748,y=4,z=-446,dx=4,dy=2,dz=0]
particle flame 744 4 -450 1.2 0.8 0.3 0 10 force @a
kill @a[scores={player=1..,ratKing=1..},x=742,y=4,z=-450,dx=4,dy=2,dz=0]

#dispensers alternative side
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1}] run playsound block.piston.contract master @a 747 5 -455 1
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1..40}] run particle dust 1 0 0 1 747 4.4 -455 2.6 0.1 0.1 1 12 force @a
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1..40}] run particle dust 1 0 0 1 747 5.4 -455 2.6 0.1 0.1 1 12 force @a
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=1..40}] run kill @a[scores={player=1..,ratKing=1..},x=742,y=4,z=-455,dx=10,dy=2,dz=0]

execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41}] run playsound block.piston.contract master @a 747 5 -459 1
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41..80}] run particle dust 1 0 0 1 747 4.4 -459 2.6 0.1 0.1 1 12 force @a
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41..80}] run particle dust 1 0 0 1 747 5.4 -459 2.6 0.1 0.1 1 12 force @a
execute if entity @e[type=slime,tag=ratKing,scores={dispenserT=41..80}] run kill @a[scores={player=1..,ratKing=1..},x=742,y=4,z=-459,dx=10,dy=2,dz=0]

#reset dispenserT
scoreboard players reset @e[type=slime,tag=ratKing,scores={dispenserT=80..}] dispenserT

#stuck in cobwebs/change move
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] at @s run playsound entity.silverfish.hurt master @a ~ ~ ~-6 10 0.3
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] run tag @s remove move1
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] run tag @s add move2
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] run data merge entity @s {NoAI:0,Silent:1,NoGravity:1,Health:1,Attributes:[{Name:"generic.attackDamage",Base:14.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.followRange",Base:0.0},{Name:"generic.attackKnockback",Base:6.0},{Name:"generic.maxHealth",Base:1.0}]}
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] run summon evoker 747 4 -608 {Rotation:[180.0f,0.0f],Silent:1,Invulnerable:0,PersistenceRequired:1,Tags:["illusioner"],NoAI:0,Health:100,Attributes:[{Name:"generic.maxHealth",Base:100.0}]}
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] run team join mob @e[type=evoker,tag=illusioner]
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] at @e[type=evoker,tag=illusioner] run playsound entity.illusioner.mirror_move master @a ~ ~ ~ 7
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] at @e[type=evoker,tag=illusioner] run particle witch ~ ~1 ~ 0.4 0.6 0.4 0 100 force @a
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] run bossbar add ratking {"text":"The Rat King"}
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] run bossbar set ratking color purple
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] run bossbar set ratking players @a
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] run bossbar set ratking style progress
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] run bossbar set ratking visible true
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] run scoreboard objectives add bossHP dummy
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] as @e[tag=illusioner,type=evoker] store result bossbar ratking value run data get entity @s Health
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] as @e[tag=illusioner,type=evoker] store result bossbar ratking max run data get entity @s Attributes[0].Base
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] as @e[tag=illusioner,type=evoker] store result score @s bossHP run data get entity @s Health
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] at @e[tag=illusioner,type=evoker] run summon area_effect_cloud ~ ~ ~ {Duration:2147483647,Tags:["followFake"],PersistenceRequired:1,NoGravity:1,Invulnerable:1} 
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] at @s run tp @s ~ 4 ~
execute as @s[x=742,y=4,z=-607.5,dx=10,dy=20,dz=-1,tag=!stuck] run tag @s add stuck